## Saxon.Api

Class DocumentBuilder

Class DomDestination

Class DynamicError

Class NullDestination

Class Processor

Class QName

Class SchemaManager

Class SchemaValidator

Class SequenceEnumerator

Class Serializer

Class StaticError

Class TextWriterDestination

Class XPathCompiler

Class XPathExecutable

Class XPathSelector

Class XQueryCompiler

Class XQueryEvaluator

Class XQueryExecutable

Class XdmAtomicValue

Class XdmDestination

Class XdmEmptySequence

Class XdmItem

Class XdmNode

Class XdmValue

Class XmlDestination

Class XsltCompiler

Class XsltExecutable

Class XsltTransformer

Enum RecoveryPolicy

Enum SchemaValidationMode

Enum TreeModel

Enum WhitespacePolicy

Enum XdmAxis

Interface IMessageListener

Interface IQueryResolver

Interface IResultDocumentHandler

Interface IXmlLocation

Interface SchemaResolver

## Saxon.Api
Class DocumentBuilder

    public class DocumentBuilder

implements object

  The `DocumentBuilder` class enables XDM documents to be built from various sources. The class is always instantiated using the `NewDocumentBuilder` method on the `Processor` object.

Property Summary
`` | `XmlResolver` An XmlResolver, which will be used to resolve URIs of documents being loaded and of references to external entities within those documents (including any external DTD).
`bool` | `IsLineNumbering` Determines whether line numbering is enabled for documents loaded using this `DocumentBuilder`.
`` | `SchemaValidationMode` Determines whether schema validation is applied to documents loaded using this `DocumentBuilder`, and if so, whether it is strict or lax.
`QName` | `TopLevelElementName` The required name of the top level element in a document instance being validated against a schema.
`bool` | `DtdValidation` Determines whether DTD validation is applied to documents loaded using this `DocumentBuilder`.
`` | `WhitespacePolicy` Determines the whitespace stripping policy applied when loading a document using this `DocumentBuilder`.
`` | `TreeModel` The Tree Model implementation to be used for the constructed document. By default the TinyTree is used. The main reason for using the LinkedTree alternative is if updating is required (the TinyTree is not updateable)
`Uri` | `BaseUri` The base URI of a document loaded using this `DocumentBuilder`. This is used for resolving any relative URIs appearing within the document, for example in references to DTDs and external entities.

Method Summary
`XdmNode` | `Build(System.Uri uri)` Load an XML document, retrieving it via a URI.
`XdmNode` | `Build(System.IO.Stream input)` Load an XML document supplied as raw (lexical) XML on a Stream.
`XdmNode` | `Build(System.Xml.XmlNode source)` Load an XML DOM document, supplied as an `XmlNode`, into a Saxon XdmNode.
`XdmNode` | `Build()`
`XdmNode` | `Wrap(System.Xml.XmlDocument doc)` Wrap an XML DOM document, supplied as an `XmlNode`, as a Saxon XdmNode.

Property Detail

### XmlResolver

    public  XmlResolver {get; set; }

  An XmlResolver, which will be used to resolve URIs of documents being loaded and of references to external entities within those documents (including any external DTD).

  By default an `XmlUrlResolver` is used. This means that the responsibility for resolving and dereferencing URIs rests with the .NET platform (and not with the GNU Classpath).

  When Saxon invokes a user-written `XmlResolver`, the `GetEntity` method may return any of: a `System.IO.Stream`; a `System.IO.TextReader`; or a `java.xml.transform.Source`. However, if the `XmlResolver` is called by the XML parser to resolve external entity references, then it must return an instance of `System.IO.Stream`.

### IsLineNumbering

    public bool IsLineNumbering {get; set; }

  Determines whether line numbering is enabled for documents loaded using this `DocumentBuilder`.

  By default, line numbering is disabled.

  Line numbering is not available for all kinds of source: in particular, it is not available when loading from an existing XmlDocument.

  The resulting line numbers are accessible to applications using the extension function saxon:line-number() applied to a node.

  Line numbers are maintained only for element nodes; the line number returned for any other node will be that of the most recent element.

### SchemaValidationMode

    public  SchemaValidationMode {get; set; }

  Determines whether schema validation is applied to documents loaded using this `DocumentBuilder`, and if so, whether it is strict or lax.

  By default, no schema validation takes place.

  This option requires the schema-aware version of the Saxon product (Saxon-SA).

### TopLevelElementName

    public QName TopLevelElementName {get; set; }

  The required name of the top level element in a document instance being validated against a schema.

  If this property is set, and if schema validation is requested, then validation will fail unless the outermost element of the document has the required name.

  This option requires the schema-aware version of the Saxon product (Saxon-SA).

### DtdValidation

    public bool DtdValidation {get; set; }

  Determines whether DTD validation is applied to documents loaded using this `DocumentBuilder`.

  By default, no DTD validation takes place.

### WhitespacePolicy

    public  WhitespacePolicy {get; set; }

  Determines the whitespace stripping policy applied when loading a document using this `DocumentBuilder`.

  By default, whitespace text nodes appearing in element-only content are stripped, and all other whitespace text nodes are retained.

### TreeModel

    public  TreeModel {get; set; }

  The Tree Model implementation to be used for the constructed document. By default the TinyTree is used. The main reason for using the LinkedTree alternative is if updating is required (the TinyTree is not updateable)

### BaseUri

    public Uri BaseUri {get; set; }

  The base URI of a document loaded using this `DocumentBuilder`. This is used for resolving any relative URIs appearing within the document, for example in references to DTDs and external entities.

  This information is required when the document is loaded from a source that does not provide an intrinsic URI, notably when loading from a Stream or a TextReader.

Method Detail

### Build

    public XdmNode Build(System.Uri uri)

  Load an XML document, retrieving it via a URI.

  Note that the type `Uri` requires an absolute URI.

  The URI is dereferenced using the registered `XmlResolver`.

  This method takes no account of any fragment part in the URI.

  The `role` passed to the `GetEntity` method of the `XmlResolver` is "application/xml", and the required return type is `System.IO.Stream`.

  The document located via the URI is parsed using the `System.Xml` parser.

  Note that the Microsoft `System.Xml` parser does not report whether attributes are defined in the DTD as being of type `ID` and `IDREF`. This is true whether or not DTD-based validation is enabled. This means that such attributes are not accessible to the `id()` and `idref()` functions.

  Parameters:
  `uri` -
    The URI identifying the location where the document can be found. This will also be used as the base URI of the document (regardless of the setting of the `BaseUri` property).
  returns
    An `XdmNode`. This will be the document node at the root of the tree of the resulting in-memory document.

### Build

    public XdmNode Build(System.IO.Stream input)

  Load an XML document supplied as raw (lexical) XML on a Stream.

  The document is parsed using the `System.Xml` parser.

  Before calling this method, the BaseUri property must be set to identify the base URI of this document, used for resolving any relative URIs contained within it.

  Note that the Microsoft `System.Xml` parser does not report whether attributes are defined in the DTD as being of type `ID` and `IDREF`. This is true whether or not DTD-based validation is enabled. This means that such attributes are not accessible to the `id()` and `idref()` functions.

  Parameters:
  `input` -
    The Stream containing the XML source to be parsed
  returns
    An `XdmNode`, the document node at the root of the tree of the resulting in-memory document

### Build

    public XdmNode Build(System.Xml.XmlNode source)

  Load an XML DOM document, supplied as an `XmlNode`, into a Saxon XdmNode.

  The returned document will contain only the subtree rooted at the supplied node.

  This method copies the DOM tree to create a Saxon tree. See the `Wrap` method for an alternative that creates a wrapper the DOM tree, allowing it to be modified in situ.

  Parameters:
  `source` -
    The DOM Node to be copied to form a Saxon tree
  returns
    An `XdmNode`, the document node at the root of the tree of the resulting in-memory document

### Build

    public XdmNode Build()

### Wrap

    public XdmNode Wrap(System.Xml.XmlDocument doc)

  Wrap an XML DOM document, supplied as an `XmlNode`, as a Saxon XdmNode.

  This method must be applied at the level of the Document Node. Unlike the `Build` method, the original DOM is not copied. This saves memory and time, but it also means that it is not possible to perform operations such as whitespace stripping and schema validation.

  Parameters:
  `doc` -
    The DOM document node to be wrapped
  returns
    An `XdmNode`, the Saxon document node at the root of the tree of the resulting in-memory document